# Flutter Cognito Plugin

An AWS Cognito plugin for flutter. Supports both iOS and Android.

![Sponsor](https://img.shields.io/badge/Sponsor-jaaga_labs-red.svg?style=for-the-badge&link=https://www.jaaga.in/labs


## Installation

**ios/Podfile** -- Ensure ios version is set to a minimum of `9.0`.
```podspec
platform :ios, '9.0'
```

Add an `awsconfiguration.json` file to `android/app/src/main/res/raw/awsconfiguration.json` and `ios/awsconfiguration.json`

This is typically what one looks like -

```json
{
  "Version": "1.0",
  "CredentialsProvider": {
    "CognitoIdentity": {
      "Default": {
        "PoolId": "REPLACE_ME",
        "Region": "REPLACE_ME"
      }
    }
  },
  "IdentityManager": {
    "Default": {}
  },
  "CognitoUserPool": {
    "Default": {
      "AppClientSecret": "REPLACE_ME",
      "AppClientId": "REPLACE_ME",
      "PoolId": "REPLACE_ME",
      "Region": "REPLACE_ME"
    }
  }
}
```


This plugin supports the amplify SDK for android and iOS,
and the the amplify cli can be used to generate the `awsconfiguration.json` file.